
#include <sax2/Attributes.hpp>
#include <sax2/DefaultHandler.hpp>

XERCES_CPP_NAMESPACE_USE

class jabatoBlockHandler : public DefaultHandler
{
public:
    jabatoBlockHandler();
    ~jabatoBlockHandler();

    void setAddDirectories(bool b);
    void find(int, JabatoBlock *);
    bool found();
    bool error();

    // -----------------------------------------------------------------------
    //  Implementations of the SAX DocumentHandler interface
    // -----------------------------------------------------------------------
    void characters(const XMLCh* const chars, const unsigned int length);

    void endElement( const XMLCh* const uri, 
					 const XMLCh* const localname, 
					 const XMLCh* const qname);

    void startElement(	const   XMLCh* const    uri,
						const   XMLCh* const    localname,
						const   XMLCh* const    qname,
				    const   Attributes&		attributes);

				
    // -----------------------------------------------------------------------
    //  Implementations of the SAX ErrorHandler interface
    // -----------------------------------------------------------------------
    void warning(const SAXParseException& exception);
    void error(const SAXParseException& exception);
    void fatalError(const SAXParseException& exception);

private :
	JabatoBlock *jabatoBlock;
	int        	 blockId;
	bool      	 m_found;
	bool      	 m_error;
	bool         readingBlock;
	bool         addDirectories;

	// You may know how to make this constants static class const.
  const XMLCh *BLOCK;
  const XMLCh *PROGRAMFILE;
  const XMLCh *SONGSDIR;
  const XMLCh *SLOTSDIR;
  const XMLCh *TEXTSDIR;

  const XMLCh *ID;
  const XMLCh *NAME;
  const XMLCh *SONGSPERSLOT;
  const XMLCh *SHUFFLE;

  const XMLCh *PATH;
  const XMLCh *TOLANDISKCMD;
  const XMLCh *TOWANDISKCMD;

};
